<? /*************************************************************************************************
Copyright (c) 2003, 2004 Nathan 'Random' Rini
This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*************************************************************************************************/
 /*
  Game List Class
 */

 class db_games {
  var $games; //game array - holds reference to game

  //save all changes to db
  function update_db(){
   if(!empty($this->games))
    foreach($this->games as $game)
     if(!empty($game->data_mod) && $game->id > 0)
      new db_cmd("UPDATE", "games", $game->data_mod, "id='".$game->id."'", 1);
  }

  //retrieve a game
  function &game($id = 0, $create = 0){
   if(!empty($this->games[$id])) return $this->games[$id];
   else {
    if(!($id > 0) && $create) $id = $this->create();
    return $this->games[$id] = new db_game($id);
  }}

  //find game
  function &find_game($name){
   $query = new db_cmd("select", "games", "id", "name LIKE '".convertsqlquotes($name)."'", 1);

   return $this->game($query->data[0]["id"]);
  }

  //create new game and then query it
  function create(){
   //grab next id
   $id = $GLOBALS["querys"]->nextid("games", "id");

   //create entry
   new db_cmd("insert", "games", array("id" => $id));

   return $id;
  }
 }

 class db_game {
  var $id;       //id
  var $data;     //data
  var $data_mod; //modified data

  function db_game($id = 0){
   $this->id = $id;

   if($id == '' || $id == 0) return;

   $query = new db_cmd("select", "games", "*", "id='".$this->id."'", 1);
   $this->data = & $query->query->db_data[0]; //reference all user info

   $this->id = $this->get("id");
  }

  function delete(){
   new db_cmd("delete", "games", "", "id = ".$this->id);

   $this->id = 0;
   $this->data = '';
   $this->data_mod = '';
  }

  function get($name){
   return $this->data[$name];
  }

  function set($name = '', $value = ''){
   if(is_array($name))
    foreach($name as $key => $data)
     $this->data_mod[$key] = $this->data[$key] = $data;
   else if($name != '')
    $this->data_mod[$name] = $this->data[$name] = $value;
  }
 }

 //writes out option list of games
 function write_game_optlist($list){
  $query = new db_cmd("select", "games", array("id", "name"), '', '', "name ASC");

  foreach($query->data as $game)
   $gamelist .= write_option($game["name"], findvalue($list, $game["id"]));

  return $gamelist;
 }

 //retrive game by index
 function getgame($id){global $games;
  $game = &$games->game($id);

  if($game->id > 0) return $game->get("name");
 }

 //adds game by name to list
 function addlistgame($list, $name){global $games;
  $game = &$games->find_game($name);

  if($game->id > 0) return addvalue($list,$game->id);
  else return $list;
 }

?>